clear

m = 25222;
g = 9.8;
l = 22;
Jo = 4.07*10^6;
v_ar = 17.1;
Fv = 166.23*(v_ar^2);
Fp = sqrt(((Fv/2)^2) + (268000^2));
Fps = -Fv/2;
phi = -0.09;
theta = 0;

function dx=foguetenl(t,x)
    dx(1) = x(2)
    dx(2) = (Fv + Fps + Fp*sin(theta + phi))/m
    dx(3) = x(4)
    dx(4) = (Fp*cos(theta+phi) - Fps*theta - m*g)/m
    dx(5) = x(6)
    dx(6) = (Fps*l - Fp*l*sin(phi))/Jo
endfunction

A = [0 1 0 0 0 0;
     0 0 0 0 (Fp*cos(theta+phi)/m) 0;
     0 0 0 1 0 0;
     0 0 0 0 ((-Fp*sin(theta+phi)-Fps)/m) 0;
     0 0 0 0 0 1;
     0 0 0 0 0 0];

B = [0 0 0 0 0;
     1/m 1/m (sin(theta+phi)/m) ((Fp*cos(theta+phi))/m) 0;
     0 0 0 0 0;
     0 (-theta/m) (cos(theta+phi)/m) ((-Fp*sin(theta+phi))/m) (-1/m);
     0 0 0 0 0;
     0 l/Jo (-sin(phi)*l/Jo) (-Fp*cos(phi)*l/Jo) 0];

C = [1 0 0 0 0 0;
     0 1 0 0 0 0;
     0 0 1 0 0 0;
     0 0 0 1 0 0;
     0 0 0 0 1 0;
     0 0 0 0 0 1];

D = [0 0 0 0 0;
     0 0 0 0 0;
     0 0 0 0 0;
     0 0 0 0 0;
     0 0 0 0 0;
     0 0 0 0 0];

% funçõe de transferência
s = poly(0,'s') % definindo a variável complexa s
F_s = inv(s*eye(A)-A) % matriz resolvente (nxn)
%denominador (polinômio de grau n)
Func = det(s*eye(A)-A)
%polos (n polos)
polos = roots(Func)
%matriz de transferência (mxp); G(i,j) = Y(i)/U(j)
G = syslin('c',C*F_s*B)
% exibindo informações relevantes 
disp('Fv = '+string(Fv)+'; Fps = '+string(Fps)+'; Fp = '+string(Fp)+'; phi = '+string(phi))
disp('Funcao caracteristica:')
disp(Func)
disp('polos:')
disp(polos)
disp('G:')
disp(G)

% Diagramas de Bode 
if G(1,1) ~= 0 then
 xset('window',1)
 bode(G(1,1))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: Fv/m/s^2$')
end
if G(1,2) ~= 0 then
 xset('window',2)
 bode(G(1,2))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: Fps/m/s^2$')
end
if G(1,3) ~= 0 then
 xset('window',3)
 bode(G(1,3))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: Fp*sin(theta+phi)/m/s^2$')
end
if G(1,4) ~= 0 then
 xset('window',4)
 bode(G(1,4))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: Fp*cos(theta+phi)/m/s^2$')
end
if G(1,5) ~= 0 then
 xset('window',5)
 bode(G(1,5))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: Fp*cos(theta+phi)/m/s^2$')
end
if G(2,1) ~= 0 then
xset('window',6)
 bode(G(2,1))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: -Fps*theta/m/s^2$')
end
if G(2,2) ~= 0 then
xset('window',7)
 bode(G(2,2))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: Fp*cos(theta+phi)/m/s^2$')
end
if G(2,3) ~= 0 then
 xset('window',8)
 bode(G(2,3))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: -phi*Fp*sin(theta+phi)/m/s^2$')
end
if G(3,1) ~= 0 then
 xset('window',12)
 bode(G(3,1))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: Fps*l/Jo/s^2$')
end
if G(3,2) ~= 0 then
 xset('window',13)
 bode(G(3,2))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: -Fp*phi*cos(phi)*l/Jo/s^2$')
end
if G(3,3) ~= 0 then
 xset('window',14)
 bode(G(3,3))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: Fps*l/Jo/s^2$')
end
if G(3,4) ~= 0 then
 xset('window',15)
 bode(G(3,4))
 xtitle('$\LARGE Diagramas\: de\: Bode: \: -Fp*sin(phi)*l/Jo/s^2$')
end
