// Análise no Domínio de Laplace

// Parametros Iniciais
m = 25222;
g = 9.8;
l = 22;
Jo = 4.07*10^6;
v_ar = 17.1;
Fv = 166.23*(v_ar^2);
Fp = sqrt(((Fv/2)^2) + (268000^2));
Fps = -Fv/2;
theta = 0.1;
phi = -0.09;

// Movimento X
// X/Fv(s)
G_X_Fv = syslin('c',(1)/(m*s^2))
figure
plzr(G_X_Fv)

// X/Fps(s)
G_X_Fps = syslin('c',(1)/(m*s^2))
figure
plzr(G_X_Fps)

// X/Fp(s)
G_X_Fp = syslin('c',(sin(theta + phi))/(m*s^2))
figure
plzr(G_X_Fp)

// X/Phi(s)
G_X_Phi = syslin('c',(Fp * cos(theta + phi))/(m*s^2))
figure
plzr(G_X_Phi)

// Movimento Y
// Y/Fps(s)
G_Y_Fps = syslin('c',(- theta)/(m*s^2))
figure
plzr(G_Y_Fps)

// Y/Fp(s)
G_Y_Fp = syslin('c',(cos(theta + phi))/(m*s^2))
figure
plzr(G_Y_Fp)

// Y/Phi(s)
G_Y_Phi = syslin('c',(- Fp * sin(theta + phi))/(m*s^2))
figure
plzr(G_Y_Phi)

// Y (s) (Em função da entrada Peso [P])
G_Y_P = syslin('c',(- g)/(s^3))
figure
plzr(G_Y_P)

// Movimento theta
// Theta/Fps(s)
G_Theta_Fps = syslin('c',(l)/(Jo*s^2))
figure
plzr(G_Theta_Fps)

// Theta/Fp(s)
G_Theta_Fp = syslin('c',(- sin(phi)*l)/(Jo*s^2))
figure
plzr(G_Theta_Fp)

// Theta/Phi(s)
G_Theta_Phi = syslin('c',(Fp * cos(phi)*l)/(Jo*s^2))
figure
plzr(G_Theta_Phi)
